//+------------------------------------------------------------------+
//|                                              NeuroMACDwithMM.mq4 |
//|                             Copyright  2007, Victor I/ Nicolaev |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Victor I/ Nicolaev"
#property link      "vinin@mail.ru"

//---- input parameters

extern int  x0 = 70;
extern int  x1 = 77;
extern int  x2 = 109;
extern int  x3 = 52;
extern int  tp = 70;
extern int  sl = 70;
extern int  EMA=5;
extern double       MaximumRisk = 0.02;
extern int mode=0;
extern int modeP=0;
int period[]={1440,240,60,30,15,5};
static int          prevtime[5];
static double       minlot = 0.1;
extern double lots=1.0;

int Count=5;
int CountP=5;
int iVar[5][5][5];
int dVar[5][2];
int Magic[]={200700,200201,200702,200703,200704};
//dVar000000=191;
//dVar000100=193;
//iVar000000=124;
//iVar000001=  6;


double StartBalance,MaxEqu,MaxDD;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   int i,j,k;
   minlot = MarketInfo(Symbol(), MODE_MINLOT);
   if (IsTesting()) {
      StartBalance = AccountBalance();
      MaxEqu = 0;
      MaxDD = 0;
      ArrayInitialize(iVar,100);
      ArrayInitialize(dVar,100);
      for (k=0;k<CountP;k++) {
         for (i=0;i<Count;i++)
            for (j=0;j<5;j++)
               if (CheckGlobalVariable("iVar",k,i,j))
                  iVar[k,i,j]=GetGlobalVariable("iVar",k,i,j);
         for (i=0;i<2;i++)
            if (CheckGlobalVariable("dVar",k,i,0))
               dVar[k,i]=GetGlobalVariable("dVar",k,i,0);
      }
      if (mode>0) {
         iVar[modeP-1,mode-1,0]=x0;
         iVar[modeP-1,mode-1,1]=x1;
         iVar[modeP-1,mode-1,2]=x2;
         iVar[modeP-1,mode-1,3]=x3;
         iVar[modeP-1,mode-1,4]=EMA;
         dVar[modeP-1,0]=tp;
         dVar[modeP-1,1]=sl;
      }
   }
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit(){
   int i,j,k;
   if (IsTesting()) {
      if (AccountEquity() > MaxEqu) MaxEqu = AccountEquity();
      if (MaxEqu-AccountEquity() > MaxDD) MaxDD = MaxEqu-AccountEquity();
      int Criterion_old = 0;
      if(GlobalVariableCheck("Criterion")) Criterion_old=GlobalVariableGet("Criterion");
      int Criterion = AccountBalance()-StartBalance;
      if( Criterion>Criterion_old) {
         for (j=0;j<5;j++)
            SetGlobalVariable("iVar",iVar[modeP-1,mode-1,j],modeP-1,mode-1,j);
         SetGlobalVariable("dVar",dVar[modeP-1,0],modeP-1,0,0);
         SetGlobalVariable("dVar",dVar[modeP-1,1],modeP-1,1,0);
         GlobalVariableSet("Criterion",Criterion);
      }
   }
   return(0);
  }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   if (AccountEquity() > MaxEqu) MaxEqu = AccountEquity();
   if (MaxEqu-AccountEquity() > MaxDD) MaxDD = MaxEqu-AccountEquity();

   int i;
   for (i=0;i<CountP;i++)
      start_period(i);
}


int start_period(int iP) {
   Order_Modify(Magic[iP],iP);
   if (iTime(Symbol(),period[iP],0) == prevtime[iP]) return(0);
   prevtime[iP] = iTime(Symbol(),period[iP],0);
   double dMA1=iMA(Symbol(),period[iP],8,0,MODE_EMA,MODE_CLOSE,1);
   double dMA2=iMA(Symbol(),period[iP],8,0,MODE_EMA,MODE_CLOSE,2);
   double dMA3=iMA(Symbol(),period[iP],8,0,MODE_EMA,MODE_CLOSE,3);
   int cnt=0;
   int cmdMA=0;
   if(dMA1>dMA2 && dMA2<=dMA3) cmdMA=1;
   if(dMA1<dMA2 && dMA2>=dMA3) cmdMA=-1;
   double cmd=perceptron(iP,cnt);
//   Print("--1--",cmd_buy_open,"; ",cmd_buy_close,"; ",cmd_sell_open,"; ",cmd_sell_close);
   double lt = minlot;   
   lots=MathCeil(getLots()*cnt/Count/minlot)*minlot;
   int total=TotalMagic(Magic[iP]);
   if (cmd>0 && total>0) {
      Order_Close(OP_SELL,Magic[iP]);   
      total=TotalMagic(Magic[iP]);
   }
   if (cmd<0 && total>0) {
      Order_Close(OP_BUY,Magic[iP]);   
      total=TotalMagic(Magic[iP]);
   }
   if (cmdMA>0 && cmd>0 && total==0) Order_Open(OP_BUY,Magic[iP],iP);
   if (cmdMA<0 && cmd<0 && total==0) Order_Open(OP_SELL,Magic[iP],iP);
   return(0);
  }
//+------------------------------------------------------------------+

double getLots() {
   int round = MathAbs(MathLog(minlot) / MathLog(10.0)) + 0.5;
   double lot = minlot;
//---- select lot size
   lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk / 1000.0, round);
   if (AccountFreeMargin() < lot * MarketInfo(Symbol(), MODE_MARGINREQUIRED)) {
      lot = NormalizeDouble(AccountFreeMargin() / MarketInfo(Symbol(), MODE_MARGINREQUIRED), round);
   }
   if(lot < minlot) lot = minlot;
   double maxlot = MarketInfo(Symbol(), MODE_MAXLOT);
   if(lot > maxlot) lot = maxlot;
//---- return lot size
   return(lot);
}

double perceptron(int iP,int &cnt)   {
   double a[5],tmp[],tmp2=0;
   ArrayResize(tmp,Count);
   int i,j;
   cnt=0;
   for (i=0;i<Count;i++){
      tmp[i]=0;
      for (j=0;j<4;j++) {
         a[j]=iClose(Symbol(),period[iP],5*j)-iMA(Symbol(),period[iP],iVar[iP,i,4],0,MODE_EMA,MODE_CLOSE,5*j);
         tmp[i]+=(iVar[iP,i,j]-100.0)*a[j];
      }
      if (MathAbs(tmp[i])>MathAbs(tmp2)) tmp2=tmp[i];
   }
   for (i=0;i<Count;i++){
      if (tmp2>0 && tmp[i]>0) cnt++;
      if (tmp2<0 && tmp[i]<0) cnt++;
   }
   return(tmp2);
  }

int TotalMagic(int Magic){
   int Count=0;
   int total = OrdersTotal();
   for (int i = 0; i < total; i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic) 
         Count++;

   }
   return(Count);
}

bool Order_Modify(int Magic, int iP){
   double _sl, _tp;
   int _cmd;
   int total= OrdersTotal();   
   for(int i = total - 1; i >= 0; i--) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES); 
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == Magic) {
         _cmd=-Sign(OrderType()-0.5);
         _sl=iif(_cmd>0,Bid,Ask) - _cmd*dVar[iP,1] * Point;
         _tp=iif(_cmd>0,Bid,Ask) + _cmd*dVar[iP,0] * Point;
         if ((_sl-OrderStopLoss())*_cmd>0)
            OrderModify(OrderTicket(), OrderOpenPrice(), _sl, _tp, 0, iif(_cmd>0,Blue,Red));
      }
   }
}
void Order_Close(int cmd, int Magic){
   int total= OrdersTotal();   
   for(int i = total - 1; i >= 0; i--) 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES) 
      && OrderSymbol() == Symbol() 
      && OrderMagicNumber() == Magic
      && OrderType()==cmd)
         OrderClose(OrderTicket(), OrderLots(), iif(cmd==OP_BUY,Bid,Ask), 3, iif(cmd==OP_BUY,Red,Blue));
}

int Sign(double A) {if(A>0) return(1);if(A<0) return(-1);return(0);}
double iif(bool A, double B, double C) {if(A) return(B);return(C);}

int Order_Open(int cmd,int Magic, int iP){
   int _cmd=-Sign(cmd-0.5);
   double price= iif(cmd==OP_BUY,Ask,Bid);
   double _sl=iif(cmd==OP_BUY,Bid,Ask) - _cmd*dVar[iP][1] * Point;
   double _tp=iif(cmd==OP_BUY,Bid,Ask) + _cmd*dVar[iP][0] * Point;
   int ticket=OrderSend(Symbol(), cmd, lots,price, 3,_sl, _tp,"proba",Magic, 0, iif(cmd==OP_BUY,Blue,Red));
   return(ticket);
}

bool CheckGlobalVariable(string sVar,int i=0, int j=0,int k=0){
   string stmp=sVar;   
   if (i<10) stmp=stmp+"0"+i; else stmp=stmp+i; 
   if (j<10) stmp=stmp+"0"+j; else stmp=stmp+j;
   if (k<10) stmp=stmp+"0"+k; else stmp=stmp+k;
   return(GlobalVariableCheck(stmp));
}


void SetGlobalVariable(string sVar,double dVar,int i=0, int j=0, int k=0){
   string stmp=sVar;   
   if (i<10) stmp=stmp+"0"+i; else stmp=stmp+i; 
   if (j<10) stmp=stmp+"0"+j; else stmp=stmp+j;
   if (k<10) stmp=stmp+"0"+k; else stmp=stmp+k;
   GlobalVariableSet(stmp, dVar);
}

double GetGlobalVariable(string sVar,int i=0, int j=0, int k=0){
   string stmp=sVar;   
   if (i<10) stmp=stmp+"0"+i; else stmp=stmp+i; 
   if (j<10) stmp=stmp+"0"+j; else stmp=stmp+j;
   if (k<10) stmp=stmp+"0"+k; else stmp=stmp+k;
   return(GlobalVariableGet(stmp));
}